// d. bodnar 11-18-2017
// changed all to 9600 baud - seems much more stable
// This version is based on 17.3 and does not include DFPlayer code
//  sounds will be taken care of by the Wemos chip

#include <SoftwareSerial.h>
#include <TimeLib.h>
#define TIME_HEADER   'T'   // Header tag for serial time sync message
//#define TIME_REQUEST  7    // ASCII bell character requests a time sync message
int ver = 18;
int verdec = 0;
int totalMins = 0;
int totalHrs = 0;
int startHr = 0;
int startMn = 0;
SoftwareSerial mySerial(12, 13);//  RX  TX   , false, 256);
String readString;
unsigned long epoch = 0;
unsigned long LastEpoch = 0;
String inString = "";
int minCount = 0;
//unsigned long time;
//unsigned long time2;
float moveMinute = 0;
int timeFlag = 0;
int  hr = 0; // hour
int  mn = 0; // minute
int  se = 0; // second
int HourHandEveryOtherFlag = 0;
int MinuteSensorFlag = 0;
int Over59Flag = 0;
int motorPin1 = 2;    // Blue   - 28BYJ48 pin 1
int motorPin2 = 3;    // Pink   - 28BYJ48 pin 2
int motorPin3 = 4;    // Yellow - 28BYJ48 pin 3
int motorPin4 = 5;    // Orange - 28BYJ48 pin 4
int motorPin1b = 6;    // Blue   - 28BYJ48 pin 1
int motorPin2b = 7;    // Pink   - 28BYJ48 pin 2
int motorPin3b = 8;    // Yellow - 28BYJ48 pin 3
int motorPin4b = 9;    // Orange - 28BYJ48 pin 4
int HallSensorOnMinute = 10; // hall sensor - high when magnet detected
int HallSensorOnHour = 11; // smaller gear sensor
//pin 12 used in MySerial
//pin 13 used in MySerial
// not used A0--A7 (A0 to A7 on nano & mini)
//int requestTime = A2; // pull this pin LOW to request serial send of time
int stoppedFlag = 0;
int catchUpFlag = 0;
int newTimeFlag = 0;
int timeOKFlag = 0;
int hourCount = 0;
int minuteCount = 0;
int secondsNow = 0;
int foundMinuteMagnetFlag = 0;
int ticks = 0; // count 10 second periods that have passed
int motorSpeed = 1000;  //variable to set stepper speed
int count = 0;          // count of steps made
int countsperrev = 360; // number of steps per full revolution
int lookup[8] = {B01000, B01100, B00100, B00110, B00010, B00011, B00001, B01001};
int MinuteHallSensor = 0;
int HourHallSensor = 0;
//////////////////////////////////////////////////////////////////////////////
void setup() {
  //declare the motor pins as outputs
  pinMode(motorPin1, OUTPUT);
  pinMode(motorPin2, OUTPUT);
  pinMode(motorPin3, OUTPUT);
  pinMode(motorPin4, OUTPUT);
  pinMode(motorPin1b, OUTPUT);
  pinMode(motorPin2b, OUTPUT);
  pinMode(motorPin3b, OUTPUT);
  pinMode(motorPin4b, OUTPUT);
  // pinMode(requestTime, OUTPUT);

  // pinMode(13, OUTPUT);
  Serial.begin(9600);
  mySerial.begin(9600);
  // setSyncProvider( requestSync);  //set function to call when sync required
  // Serial.println("Waiting for sync message");
  pinMode(HallSensorOnMinute, INPUT);
  pinMode(HallSensorOnHour, INPUT);
  Serial.print("At Setup .... Version ");
  Serial.print (ver);
  Serial.print(".");
  Serial.println(verdec);
  // delay(500);
  // time = millis(); // used for check time on WiFi
  alignHands();  // initial routine to align both hands to noon
  while (epoch == 0) {
    getTime();
  }
  LastEpoch = epoch; // store first reading to compare with new ones
  delay(2000);
  setInitialTime();
  //  time2 = millis(); // used for hand movement
  secondsNow = second();
  totalMins = 0;
  totalHrs = 0;
  startHr = hr;
  startMn = mn;
}

void loop() {
  if (second() - secondsNow == 10 || second() - secondsNow == -50) { // 10 sec = 1 tick of stepper
    secondsNow = second();
    ticks ++;
    MinuteHand();
  }
  //  Serial.print("ticks = ");
  // Serial.println(ticks);
  if (ticks >= 12    ) {   /// changed from == when hour hand stuck or move time forward routine
    Serial.print("ticks = ");
    Serial.println(ticks);
    HourHand();  // move one tick after 12 seconds go by
    ticks = 0;
  }
  if (digitalRead(HallSensorOnMinute) == LOW && foundMinuteMagnetFlag == 0) { // minute hand at 12
    minuteMagnetAt12();
  }
  if (digitalRead(HallSensorOnMinute) == HIGH) {
    foundMinuteMagnetFlag = 0;
  }
}

void minuteMagnetAt12() {
  if (foundMinuteMagnetFlag == 0) {
    timeFlag = 0;
    Serial.println("FOUND MINUTE MAGNET FOUND MINUTE MAGNET");
    getTime();
    timeFlag = 0;
    Serial.print("epoch= ");
    Serial.println(epoch);
    Serial.print("Minute= ");
    Serial.println(mn);
    if (mn >= 1 && mn <= 30) { // 1 to 3 more minutes slow
      Serial.println("Speeding Up A ");
      for (int temp1 = 1; temp1 <=  mn; temp1++) {
        Serial.print(temp1);
        Serial.print(" ");
        Serial.print(" Speeding Up B");
        for (int temp2 = 1; temp2 <= 6  ; temp2++) {
          ticks++;
          MinuteHand();
          Serial.print(temp2);
        }
        Serial.println(" done ");
      }
    }

    if (mn <= 59 && mn >= 31) { // 1 to 3 more minutes fast
      Serial.print("pausing ");
      unsigned long tempTime = (60000 * (60 - mn));
      Serial.println(tempTime);
      Serial.println(millis());
      delay(tempTime); // pause for 1 minute
      Serial.println("done pausing...");
      Serial.println(millis());
    }
    foundMinuteMagnetFlag = 1;
  }
}

void getTime() { // receives a  10 digit # like this: 1506371296
  mySerial.flush();
  mySerial.end();    // Ends the serial communication once all data is received
  mySerial.begin(9600);  // Re-establishes serial communication - clears all buffered info
  Serial.println("Getting time ...");
  while (timeFlag == 0 && timeOKFlag == 0) {
    //    Serial.print("@ timeflag-timeOKflag test ");
    //    Serial.print(timeFlag);
    //    Serial.print("  ");
    //    Serial.println(timeOKFlag);
    if (mySerial.available() > 1) { // wait for at least two characters
      //     Serial.println("Found >1");
      char c = mySerial.read();
      //     Serial.print(" Char c = ");
      //     Serial.println(c);
      if ( c == TIME_HEADER) {   // did we get a 'T' ???
        Serial.println("@ processSyncMessage");
        processSyncMessage();
        timeFlag = 1;
      }
    }
  }
  // Serial.print("Epoch is ");
  // Serial.println(epoch);
  timeFlag = 1;
  hr = ((epoch  % 86400L) / 3600);
  hr = hr - 5; // 4 for daylight savings time in Eastern US - -5 for EST
  if (hr <= 0) hr = hr + 12;
  if (hr > 12) hr = hr - 12;
  Serial.print(hr);
  Serial.print(':');
  if ( ((epoch % 3600) / 60) < 10 ) {
    // In the first 10 minutes of each hour, we'll want a leading '0'
    Serial.print('0');
  }
  mn = ((epoch  % 3600) / 60);
  Serial.print(mn);
  Serial.print(':');
  if ( (epoch % 60) < 10 ) {
    // In the first 10 seconds of each minute, we'll want a leading '0'
    Serial.print('0');
  }
  se = (epoch % 60);
  inString = "";
  timeFlag = 1;
  timeOKFlag = 0;
}

void processSyncMessage() {
  const unsigned long DEFAULT_TIME = 1357041600; // Jan 1 2013 - paul, perhaps we define in time.h?
  epoch = 0;
  // while ( epoch <= (LastEpoch + 3500) || (epoch >= LastEpoch + 3700 ) || newTimeFlag == 0) {
  epoch = mySerial.parseInt();
  Serial.print("new PCTIME= ");
  Serial.print(epoch);
  Serial.println("");
  //  if ( epoch >= (LastEpoch + 3500) && (epoch <= LastEpoch + 3700 )) { // check the integer is a valid time (greater than Jan 1 2013)
  //    setTime(pctime); // Sync Arduino clock to the time received on the serial port
  Serial.println("OK with DEFAULT_TIME");
  timeOKFlag = 1; // set to 1 if time is OK with default time
  LastEpoch = epoch;
  //   }
  //    if (newTimeFlag == 0) {
  //      Serial.println("Got to newtimeflag");
  //      newTimeFlag = 1;
  //      LastEpoch = epoch-(60*60);
  //    }
  // }
}

void setInitialTime() {
  Serial.println("@ setInitialTime");
  Serial.print("Hr Hand Move for ");
  Serial.println(hr);
  for (count = 1; count < hr + 1  ; count++) { // goes from 1 to 12
    for (int temp2 = 1; temp2 <= 30; temp2++) {
      HourHand();
      delay(10);
    }
  }
  Serial.println("");
  Serial.print("min Hand Move for ");
  Serial.println (mn);
  for (count = 1; count < mn + 1  ; count++) { // goes from 1 to 60
    // Serial.println("");
    for (int temp2 = 1; temp2 <= 6; temp2++) {
      MinuteHand();
      delay(10);
    }
  }
  // need to adjust hour hand for proportion that he minute has moved of 60 minutes
  Serial.println(  mn / 2);
  Serial.print("adjusting Hour Hand a bit ");
  for (int temp2 = 1; temp2 <=   mn / 2; temp2++) {
    HourHand();
    delay(10);
    Serial.print(temp2);
    Serial.print(" ");
  }
  Serial.println("");
}

void alignHands() {
  Serial.println("At alignHands");
  MinuteHallSensor = digitalRead(HallSensorOnMinute);
  HourHallSensor = digitalRead(HallSensorOnHour);
  //  int xxx = 0;
  //  do  {
  //    MinuteHallSensor = digitalRead(HallSensorOnMinute);
  //    HourHallSensor = digitalRead(HallSensorOnHour);
  //    Serial.print(MinuteHallSensor);
  //    Serial.print(" ");
  //    Serial.println(HourHallSensor);
  //  }
  //  while (xxx == 0);
  if (MinuteHallSensor == LOW || HourHallSensor == LOW) {
    Serial.println("MOVING BOTH HANDS FROM MAGNETS");
    for (int temp = 0; temp < 50; temp++) {
      Serial.print(temp);
      Serial.print(" ");
      MinuteHand();
      HourHand();
    }
  }
  for (count = 1; count < countsperrev * 2; count++) { // goes from 1 to 360
    if (catchUpFlag == 0) {
      MinuteHand();
      //  Serial.print("Moving Minute Hand ");
    }
    MinuteHallSensor = digitalRead(HallSensorOnMinute);
    HourHallSensor = digitalRead(HallSensorOnHour);
    // Serial.print(MinuteHallSensor);
    //  Serial.print(" ");
    //  Serial.println(HourHallSensor);
    // Flag added so bottom magnet can't weaken upper and show HIGH when it passes
    if (MinuteHallSensor == LOW) MinuteSensorFlag = 1;
    if (MinuteSensorFlag == 1) { // goes low when hit by magnet
      catchUpFlag = 1;
      HourHand();
      // Serial.print("Moving Hour Hand  ");
      HourHallSensor = digitalRead(HallSensorOnHour);
      if (HourHallSensor == LOW) {
        break;
      }
    }
  }
  Serial.println("ALIGNED!!!");
  MinuteSensorFlag = 0;
}

void MinuteHand()
{
  totalMins ++;
  for (int i = 7; i >= 0; i--)
  {
    setMinuteHand(i);
    delayMicroseconds(motorSpeed);
  }
  allLow();
}

void HourHand()
{
  totalHrs ++;
  for (int i = 7; i >= 0; i--)// was 7 now 3
  {
    setHourHand(i);
    delayMicroseconds(motorSpeed);
  }
  allLow();
}

void setMinuteHand(int out)
{
  digitalWrite(motorPin1b, bitRead(lookup[out], 3));
  digitalWrite(motorPin2b, bitRead(lookup[out], 2));
  digitalWrite(motorPin3b, bitRead(lookup[out], 1));
  digitalWrite(motorPin4b, bitRead(lookup[out], 0));
}

void setHourHand(int out)
{
  digitalWrite(motorPin1, bitRead(lookup[out], 3));
  digitalWrite(motorPin2, bitRead(lookup[out], 2));
  digitalWrite(motorPin3, bitRead(lookup[out], 1));
  digitalWrite(motorPin4, bitRead(lookup[out], 0));
}

void allLow()
{
  digitalWrite(motorPin1b, LOW );
  digitalWrite(motorPin2b, LOW );
  digitalWrite(motorPin3b, LOW);
  digitalWrite(motorPin4b, LOW );
  digitalWrite(motorPin1, LOW );
  digitalWrite(motorPin2, LOW );
  digitalWrite(motorPin3, LOW );
  digitalWrite(motorPin4, LOW );
}


